@import '~@angular/material/theming';
@import '../global.scss';
@import '../custom-variables';

@mixin mat-custom-form-field-theme($theme) {
  $accent: map-get($theme, accent);
  $primary: map-get($theme, primary);
  $warn: map-get($theme, warn);

  .mat-form-field-appearance-outline {

    .mat-form-field-wrapper {
      padding-bottom: 0;
      margin-bottom: 0;
    }
    .mat-form-field-outline {
      display: none;
    }

    &.mat-focused {
      .mat-form-field-flex {
        border: 1px solid mat-color($primary, 700);
        box-shadow: 0 0 0 0.125rem mat-color($primary, 200);
      }
    }

    &.mat-form-field-has-label {
      padding-top: 1rem;
    }

    .mat-form-field-flex {
      $height: 1.875rem;

      border-width: 1px;
      border-style: solid;
      border-color: mat-color($accent, 400);
      border-radius: 0.25rem;
      box-shadow: none;
      padding: 0 0.5rem;
      display: flex;
      align-items: center;

      &:hover {
        border-color: mat-color($accent, 700);
      }

      .mat-form-field-infix {
        border-top: 0;
        padding: 0;
        min-height: $height;
        display: flex;
        align-items: center;
        line-height: $height;

        textarea,input{
          font-size: 0.875rem;
          line-height: 0.875rem;
        }

        .mat-form-field-label-wrapper {
          top: -50px;
          left: -9px;
          overflow: visible;
          .mat-form-field-label {
            transform: none;
            width: unset;
            margin-top: 0;
            font-weight: 700;
            font-size: 0.75rem;
          }
        }
      }


      .mat-form-field-prefix,
      .mat-form-field-suffix {
        top: -1px;
        height: $height;
        $width: 1.875rem;
        text-align: center;
        width: $width;

        mat-icon {
          height: 1.5rem;
          width: calc(1.5rem - $width);
          text-align: center;
          padding-top: 0.25rem;
          margin-right: auto;
          margin-left: auto;

          svg {
            height: 1.5rem;
            width: calc(1.5rem - $width);
          }
        }
      }

      .mat-form-field-prefix {
        right: 0.5rem;
      }

      .mat-form-field-suffix{
        right: -0.438rem;

        div {
          margin-right: -2px;
          color: mat-color($accent, 700);
          border-top-right-radius: 0.25rem;
          border-bottom-right-radius: 0.25rem;
          height: 2rem;
          line-height: 2rem;
          display: block;
          text-align: center;
          font-weight: bold;
          font-size: 0.875rem;

          background: mat-color($accent, 200) padding-box;
          border: 1px solid transparent;
          border-left: 1px solid mat-color($accent, 400);
          box-sizing: border-box;
        }
      }
    }


    .mat-form-field-underline {
      display: none;
    }

    .mat-form-field-appearance-outline .mat-form-field-subscript-wrapper {
      display: none !important;
    }

    &[small] {
      .mat-form-field-flex {
        $small-height: 1.5rem;
        height: $small-height;
        font-size: 0.75rem;

        .mat-form-field-suffix,
        .mat-form-field-prefix {
          mat-icon {
            width: 1rem;
            padding-top: 0.4rem;
            svg {
              height: 1.0rem;
            }
          }
        }

        .mat-form-field-label-wrapper {
          top: -47px;
        }

        .mat-form-field-suffix{
          right: -0.438rem;
          div {
            margin-top: 0.25rem;
            margin-right: -2px;
            color: mat-color($accent, 700);
            height: $small-height;
            line-height: $small-height;
            font-size: 0.875rem;
          }
        }

        .mat-form-field-type-mat-input input.mat-input-element {
          font-size: 0.75rem;
        }
      }
    }

    &.mat-form-field-type-mat-input {
      &.mat-focused {
        .mat-form-field-flex {
          box-shadow: 0 0 0 0.125rem mat-color($primary, 200);
        }
      }
    }


    &.mat-form-field-disabled {
      .mat-form-field-flex {
        background-color: mat-color($accent, 200);
        border-color: transparent !important;
      }
    }

    &.mat-form-field-invalid {
      &.ng-touched {
        .mat-form-field-flex {
          border: 0.0625rem solid mat-color($warn, 800);
        }
      }
    }
  }

  .mat-form-field-subscript-wrapper {
    position: relative;
  }
}
